'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = evaluate;

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function evaluate(value) {
  if (value == null) {
    return [];
  }

  if (isObject(value)) {
    return evalObject(value);
  }

  if (Array.isArray(value)) {
    return value.reduce(function (array, value) {
      if (isObject(value)) {
        array.push.apply(array, _toConsumableArray(evalObject(value)));
      } else {
        array.push.apply(array, _toConsumableArray(evalString(value)));
      }
      return array;
    }, []).filter(isNotEmpty);
  }

  return evalString(value);
}

function isObject(value) {
  return value && (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' && !Array.isArray(value);
}

function evalObject(value) {
  return Object.keys(value).reduce(function (array, key) {
    if (value[key]) {
      array.push.apply(array, _toConsumableArray(evalString(key)));
    }
    return array;
  }, []);
}

function evalString(value) {
  return String(value).split(/\s+/);
}

function isNotEmpty(value) {
  return !!value;
}